diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index c9aa34865..67b1155a2 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -8,7 +8,6 @@ import java.awt.event.MouseAdapter;
 import java.awt.event.MouseEvent;
 import java.io.File;
 import java.io.IOException;
-import java.time.ZoneId;
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Comparator;
@@ -822,7 +821,7 @@ public class Minecraft
         if(screen != null)
         {
             setIngameNotInFocus();
-            screen.init(this, resolution.getScaledWidthScreenCoords(), resolution.getScaledHeightScreenCoords());
+            screen.opened(this, resolution.getScaledWidthScreenCoords(), resolution.getScaledHeightScreenCoords());
             skipRenderWorld = false;
         } else
         {
@@ -1306,7 +1305,7 @@ public class Minecraft
     {
         resolution.setScale(gameSettings.guiScale.value);
         if(currentScreen != null) {
-            currentScreen.init(this, resolution.getScaledWidthScreenCoords(), resolution.getScaledHeightScreenCoords());
+            currentScreen.opened(this, resolution.getScaledWidthScreenCoords(), resolution.getScaledHeightScreenCoords());
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/Screen.java b/src/main/java/net/minecraft/client/gui/Screen.java
index e0f15a306..04657620f 100644
--- a/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/src/main/java/net/minecraft/client/gui/Screen.java
@@ -95,7 +95,7 @@ public abstract class Screen extends Gui {
     protected void buttonReleased(ButtonElement button) {
     }
 
-    public void init(Minecraft mc, int width, int height) {
+    public void opened(Minecraft mc, int width, int height) {
         this.mc = mc;
         font = mc.font;
         this.width = width;
diff --git a/src/main/java/net/minecraft/client/gui/SignEditorScreen.java b/src/main/java/net/minecraft/client/gui/SignEditorScreen.java
index dc09c7ac3..4f39d4e71 100644
--- a/src/main/java/net/minecraft/client/gui/SignEditorScreen.java
+++ b/src/main/java/net/minecraft/client/gui/SignEditorScreen.java
@@ -27,7 +27,7 @@ public class SignEditorScreen extends Screen
         buttons.clear();
         Keyboard.enableRepeatEvents(true);
 
-        Block block = entitySign.getBlockType();
+        Block block = entitySign.getBlock();
         if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
             yOffset = 36;
@@ -123,15 +123,15 @@ public class SignEditorScreen extends Screen
         float scale = 93.75F;
         GL11.glScalef(-scale, -scale, -scale);
         GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-        Block block = entitySign.getBlockType();
+        Block block = entitySign.getBlock();
         if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
-            float signAngle = (float)(entitySign.getMovedData() * 360) / 16F;
+            float signAngle = (float)(entitySign.getBlockMeta() * 360) / 16F;
             GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
             GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
         } else
         {
-            int meta = entitySign.getMovedData();
+            int meta = entitySign.getBlockMeta();
             float signAngle = 0.0F;
             if(meta == 2)
             {
diff --git a/src/main/java/net/minecraft/client/gui/container/CraftingScreen.java b/src/main/java/net/minecraft/client/gui/container/CraftingScreen.java
index 520fe1d65..637786438 100644
--- a/src/main/java/net/minecraft/client/gui/container/CraftingScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/CraftingScreen.java
@@ -7,16 +7,11 @@ import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
-// Referenced classes of package net.minecraft.src:
-//            GuiContainer, ContainerWorkbench, Container, FontRenderer, 
-//            RenderEngine, InventoryPlayer, World
-
 public class CraftingScreen extends AbstractContainerScreen
 {
-
-    public CraftingScreen(Inventory inventoryplayer, World world, int i, int j, int k)
+    public CraftingScreen(Inventory inventory, World world, int x, int y, int z)
     {
-        super(new CraftingMenu(inventoryplayer, world, i, j, k));
+        super(new CraftingMenu(inventory, world, x, y, z));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
index 525817d01..076039760 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
@@ -21,7 +21,7 @@ public class EntityFallingSandEntry extends EntityEntry<FallingBlockEntity>{
 
     @Override
     public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, FallingBlockEntity sand) {
-        TextCycleElement<Integer> blockIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, 0, 120, 20, sand.blockID) {
+        TextCycleElement<Integer> blockIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, 0, 120, 20, sand.carriedBlock.blockId) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return ModelViewerScreen.cycleBlockId(current, offset);
@@ -33,7 +33,7 @@ public class EntityFallingSandEntry extends EntityEntry<FallingBlockEntity>{
                     int id = Integer.parseInt(s);
                     if (Block.blocksList[id] != null) return id;
                 } catch (Exception ignored){}
-                return sand.blockID;
+                return sand.carriedBlock.blockId;
             }
 
             @Override
@@ -43,7 +43,7 @@ public class EntityFallingSandEntry extends EntityEntry<FallingBlockEntity>{
         };
         blockIdCycle.textField.setPrefaceText("ID: ");
         blockIdCycle.textField.setPlaceholder("Block ID");
-        blockIdCycle.setOnValueChanged(() -> sand.blockID = blockIdCycle.getCurrentElement());
+        blockIdCycle.setOnValueChanged(() -> sand.carriedBlock.blockId = blockIdCycle.getCurrentElement());
         return new ArrayList<ButtonElement>(){{add(blockIdCycle);}};
     }
 
diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index 32de69b52..069b0d57b 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -19,6 +19,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
+import net.minecraft.core.block.entity.BlockEntityDispatcher;
 import net.minecraft.core.block.entity.DispenserBlockEntity;
 import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
@@ -1117,12 +1118,12 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleTileEntityData(BlockEntityDataPacket packet)
     {
-        Class<?> clazz = BlockEntity.getClassFromID(packet.tag.getString("id"));
+        Class<?> clazz = BlockEntityDispatcher.getClassFromID(packet.tag.getString("id"));
         if (clazz == null) return;
         BlockEntity existingBlockEntity = worldClient.getBlockEntity(packet.tag.getInteger("x"), packet.tag.getInteger("y"), packet.tag.getInteger("z"));
         if (existingBlockEntity == null || existingBlockEntity.getClass() != clazz)
         {
-            BlockEntity blockEntity = BlockEntity.createAndLoadEntity(packet.tag);
+            BlockEntity blockEntity = BlockEntityDispatcher.createAndLoadEntity(packet.tag);
             if (blockEntity != null)
             {
                 mc.theWorld.setBlockTileEntity(blockEntity.x, blockEntity.y, blockEntity.z, blockEntity);
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 9492cf108..277fef93f 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -437,7 +437,7 @@ public class GameSettings {
 			guiScale.value = (guiScale.value + max) % max;
 			mc.resolution.setScale(guiScale.value);
 			if (mc.currentScreen != null) {
-				mc.currentScreen.init(mc, mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
+				mc.currentScreen.opened(mc, mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
 			}
 		}
 		if(option == mipmapType || option == mipmapLevels) {
@@ -457,7 +457,7 @@ public class GameSettings {
 		}
 		if(option == language) {
 			if (mc.currentScreen != null) {
-				mc.currentScreen.init(mc, mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
+				mc.currentScreen.opened(mc, mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
 			}
 		}
 		if(option == lightmapStyle) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 2a5b68615..54e66fac3 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -225,12 +225,12 @@ public class BlockModelDispatcher
         addDispatch(new CrossedSquaresBlockModel<>(Blocks.SPINIFEX).withTextures("minecraft:block/spinifex"));
         addDispatch(new AlgaeBlockModel<>(Blocks.ALGAE).withTextures("minecraft:block/algae").withCustomItemBounds(0.0f, 0.01f, 0.0f, 1.0f, 0.0125f, 1.0f));
 
-        addDispatch(new CrossedSquaresBlockModel<>(Blocks.FLOWER_YELLOW).withTextures("minecraft:block/flower_yellow"));
-        addDispatch(new CrossedSquaresBlockModel<>(Blocks.FLOWER_RED).withTextures("minecraft:block/flower_red"));
-        addDispatch(new CrossedSquaresBlockModel<>(Blocks.FLOWER_PINK).withTextures("minecraft:block/flower_pink"));
-        addDispatch(new CrossedSquaresBlockModel<>(Blocks.FLOWER_PURPLE).withTextures("minecraft:block/flower_purple"));
-        addDispatch(new CrossedSquaresBlockModel<>(Blocks.FLOWER_LIGHT_BLUE).withTextures("minecraft:block/flower_light_blue"));
-        addDispatch(new CrossedSquaresBlockModel<>(Blocks.FLOWER_ORANGE).withTextures("minecraft:block/flower_orange"));
+        addDispatch(new StackedFlowerBlockModel<>(Blocks.FLOWER_YELLOW, "minecraft:block/flower_yellow"));
+        addDispatch(new StackedFlowerBlockModel<>(Blocks.FLOWER_RED, "minecraft:block/flower_red"));
+        addDispatch(new StackedFlowerBlockModel<>(Blocks.FLOWER_PINK, "minecraft:block/flower_pink"));
+        addDispatch(new StackedFlowerBlockModel<>(Blocks.FLOWER_PURPLE, "minecraft:block/flower_purple"));
+        addDispatch(new StackedFlowerBlockModel<>(Blocks.FLOWER_LIGHT_BLUE, "minecraft:block/flower_light_blue"));
+        addDispatch(new StackedFlowerBlockModel<>(Blocks.FLOWER_ORANGE, "minecraft:block/flower_orange"));
 
         addDispatch(new CrossedSquaresBlockModel<>(Blocks.MUSHROOM_BROWN).withTextures("minecraft:block/mushroom_brown"));
         addDispatch(new CrossedSquaresBlockModel<>(Blocks.MUSHROOM_RED).withTextures("minecraft:block/mushroom_red"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
index b8973b353..3ca6f7468 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
@@ -42,8 +42,8 @@ public class PistonBlockModel<T extends PistonBaseBlock> extends StandardBlockMo
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderPistonBase(tessellator, x, y, z, false);
     }
-    @Override
-    public boolean renderNoCulling(Tessellator tessellator, int x, int y, int z) {
+
+    public boolean renderHeadless(Tessellator tessellator, int x, int y, int z) {
         renderBlocks.renderAllFaces = true;
         boolean result = renderPistonBase(tessellator, x, y, z, true);
         renderBlocks.renderAllFaces = false;
diff --git a/src/main/java/net/minecraft/client/render/block/model/StackedFlowerBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/StackedFlowerBlockModel.java
new file mode 100644
index 000000000..8112551f7
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/StackedFlowerBlockModel.java
@@ -0,0 +1,30 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.StackedFlowerBlock;
+import net.minecraft.core.util.helper.Side;
+
+public class StackedFlowerBlockModel<T extends StackedFlowerBlock> extends CrossedSquaresBlockModel<T> {
+    private final IconCoordinate[] ICONS;
+
+    public StackedFlowerBlockModel(Block block, String baseTexture) {
+        super(block);
+
+        ICONS = new IconCoordinate[T.MAX_STACK_COUNT + 1];
+        for (int i = 0; i < T.MAX_STACK_COUNT + 1; i++) {
+            ICONS[i] = TextureRegistry.getTexture(baseTexture + i);
+        }
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+        final int stackCount = T.getStackCount(data);
+        if (stackCount > T.MAX_STACK_COUNT) {
+            return ICONS[0];
+        }
+
+        return ICONS[stackCount];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java
index 285508ad3..6fa5c9352 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java
@@ -42,7 +42,7 @@ public class FlowerJarBlockEntityRenderer extends BlockEntityRenderer<FlowerJarB
                     lmc = tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0);
                 }
             }
-            BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, 0, lightLevel, lmc);
+            BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, tileEntity.flowerData, lightLevel, lmc);
         }
         GL11.glPopMatrix();
     }
diff --git a/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
index 4677ed0c6..53f7dba58 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
@@ -86,7 +86,7 @@ public class PistonBlockEntityRenderer extends BlockEntityRenderer<MovingPistonB
                     blockModelPistonHead.setFaceTextureOverride(null);
                 }
                 tessellator.setTranslation((float)x - (float)blockEntity.x, (float)y - (float)blockEntity.y, (float)z - (float)blockEntity.z);
-                pistonBase.renderNoCulling(tessellator, blockEntity.x, blockEntity.y, blockEntity.z);
+                pistonBase.renderHeadless(tessellator, blockEntity.x, blockEntity.y, blockEntity.z);
             } else
             {
                 BlockModel.setRenderBlocks(containerRenderBlock);
diff --git a/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
index 01785c6bc..134f0f8f7 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
@@ -32,19 +32,19 @@ public class SignBlockEntityRenderer extends BlockEntityRenderer<SignBlockEntity
     public void renderTileEntitySignAt(SignBlockEntity tileEntity, double d, double d1, double d2,
                                        float f)
     {
-        Block block = tileEntity.getBlockType();
+        Block block = tileEntity.getBlock();
         GL11.glPushMatrix();
         float scale = 0.6666667F;
         if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
             GL11.glTranslatef((float)d + 0.5F, (float)d1 + 0.75F * scale, (float)d2 + 0.5F);
-            float f2 = (float)(tileEntity.getMovedData() * 360) / 16F;
+            float f2 = (float)(tileEntity.getBlockMeta() * 360) / 16F;
             GL11.glRotatef(-f2, 0.0F, 1.0F, 0.0F);
             signModel.signStick.visible = true;
         }
         else
         {
-            int i = tileEntity.getMovedData();
+            int i = tileEntity.getBlockMeta();
             float f3 = 0.0F;
             if(i == 2)
             {
diff --git a/src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java b/src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java
index 3d020c599..d0c5fc0f5 100644
--- a/src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java
@@ -64,8 +64,8 @@ public class FallingBlockRenderer extends EntityRenderer<FallingBlockEntity>
         BlockModel.setRenderBlocks(containerRenderBlock);
 
         container.setLightReferenceEntity(fallingBlock);
-        container.setBlock(blockX, blockY, blockZ, fallingBlock.blockID, fallingBlock.blockMeta, fallingBlock.blockEntity);
-        BlockModelDispatcher.getInstance().getDispatch(Block.getBlock(fallingBlock.blockID)).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
+        container.setBlock(blockX, blockY, blockZ, fallingBlock.carriedBlock.blockId, fallingBlock.carriedBlock.metadata, fallingBlock.carriedBlock.entity);
+        BlockModelDispatcher.getInstance().getDispatch(Block.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
         container.setLightReferenceEntity(null);
         container.clear();
 
@@ -75,10 +75,10 @@ public class FallingBlockRenderer extends EntityRenderer<FallingBlockEntity>
         Lighting.enableLight();
         GL11.glPopMatrix();
 
-        BlockEntityRenderer<BlockEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(fallingBlock.blockEntity);
+        BlockEntityRenderer<BlockEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(fallingBlock.carriedBlock.entity);
         if (renderer != null) {
             GL11.glPushMatrix();
-            renderer.doRender(tessellator, fallingBlock.blockEntity, x - 0.5, y - 0.5, z - 0.5, partialTick);
+            renderer.doRender(tessellator, fallingBlock.carriedBlock.entity, x - 0.5, y - 0.5, z - 0.5, partialTick);
             GL11.glPopMatrix();
         }
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 4348b3fb2..4b184a97a 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -19,6 +19,7 @@ import net.minecraft.client.render.model.PlayerSlimModel;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.*;
 import net.minecraft.core.block.Block;
@@ -144,8 +145,8 @@ public class PlayerRenderer extends MobRenderer<Player>
     }
 
     public void drawHeldObject(Player player, float partialTick) {
-        if (player.getHeldObject() instanceof BlockEntity.CarriedBlock) {
-            BlockEntity.CarriedBlock carriedBlock = (BlockEntity.CarriedBlock)player.getHeldObject();
+        if (player.getHeldObject() instanceof CarriedBlock) {
+            CarriedBlock carriedBlock = (CarriedBlock)player.getHeldObject();
             if (container == null || container.world != player.world) {
                 container = new BlocksContainer(player.world);
                 containerRenderBlock = new RenderBlocks(container);
@@ -177,8 +178,8 @@ public class PlayerRenderer extends MobRenderer<Player>
             tessellator.setTranslation(-blockX -0.5, -blockY -0.5, -blockZ -0.5);
 
             container.setLightReferenceEntity(player);
-            container.setBlock(blockX, blockY, blockZ, carriedBlock.block.id, carriedBlock.metadata, carriedBlock.entity);
-            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
+            container.setBlock(blockX, blockY, blockZ, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
+            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
             tessellator.draw();
             tessellator.setTranslation(0, 0, 0);
             container.setLightReferenceEntity(null);
diff --git a/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java b/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
index fdea38f0b..63dbd8c20 100644
--- a/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
@@ -18,6 +19,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.BlockItem;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
@@ -35,6 +37,12 @@ public class BlockItemModel extends StandardItemModel {
         this.blockModel = BlockModelDispatcher.getInstance().getDispatch(block);
         icon = blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, 0);
     }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+        return this.blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, itemStack.getMetadata());
+    }
+
     @Override
     public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
         final Minecraft mc = Minecraft.getMinecraft(this);
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 28ba3374c..3842e3af3 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -816,18 +816,18 @@ public final class Blocks {
             .setBlockItem((b) -> new AlgaeBlockItem(b))
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH);
 
-        FLOWER_YELLOW = new FlowerBlock("flower.yellow", "minecraft:block/flower_yellow", 330).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedYellow)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
-        FLOWER_RED = new FlowerBlock("flower.red", "minecraft:block/flower_red", 331).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedRed)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
-        FLOWER_PINK = new FlowerBlock("flower.pink", "minecraft:block/flower_pink", 332).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedPink)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
-        FLOWER_PURPLE = new FlowerBlock("flower.purple", "minecraft:block/flower_purple", 333).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedPurple)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
-        FLOWER_LIGHT_BLUE = new FlowerBlock("flower.lightblue", "minecraft:block/flower_light_blue", 334).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedLightblue)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
-        FLOWER_ORANGE = new FlowerBlock("flower.orange", "minecraft:block/flower_orange", 335).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedOrange)
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK);
+        FLOWER_YELLOW = new StackedFlowerBlock("flower.yellow", "minecraft:block/flower_yellow", 330).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedYellow)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
+        FLOWER_RED = new StackedFlowerBlock("flower.red", "minecraft:block/flower_red", 331).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedRed)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
+        FLOWER_PINK = new StackedFlowerBlock("flower.pink", "minecraft:block/flower_pink", 332).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedPink)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
+        FLOWER_PURPLE = new StackedFlowerBlock("flower.purple", "minecraft:block/flower_purple", 333).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedPurple)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
+        FLOWER_LIGHT_BLUE = new StackedFlowerBlock("flower.lightblue", "minecraft:block/flower_light_blue", 334).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedLightblue)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
+        FLOWER_ORANGE = new StackedFlowerBlock("flower.orange", "minecraft:block/flower_orange", 335).setKilledByWeather().setBonemealable().withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedOrange)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
 
         MUSHROOM_BROWN = new MushroomBlock("mushroom.brown", "minecraft:block/mushroom_brown", 340).withSound(BlockSounds.GRASS).withHardness(0.0F).withLightEmission(0.125F).withOverrideColor(MaterialColor.paintedBrown)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.PIGS_FAVOURITE_BLOCK);
@@ -1148,7 +1148,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         COBBLE_NETHERRACK_MOSSY = new Block("cobble.netherrack.mossy", "minecraft:block/cobble_netherrack_mossy", 802, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
-        NETHERRACK = new Block("netherrack", "minecraft:block/netherrack", 803, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.32F)
+        NETHERRACK = new StoneBlock("netherrack", "minecraft:block/netherrack", 803, () -> Blocks.COBBLE_NETHERRACK, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.32F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
         BRICK_NETHERRACK = new Block("brick.netherrack", "minecraft:block/brick_netherrack", 804, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
diff --git a/src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java b/src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java
index 4e254cbd9..fb79d2f1e 100644
--- a/src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java
@@ -17,7 +17,7 @@ public class ChainlinkFenceBlock extends ThinFenceBlock
     public boolean canConnectTo(WorldSource world, int x, int y, int z)
     {
         int id = world.getBlockId(x, y, z);
-        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial == Material.stone || Block.blocksList[id].blockMaterial == Material.metal));
+        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial.isStone() || Block.blocksList[id].blockMaterial == Material.metal));
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java b/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
index 2768a0348..025397d92 100644
--- a/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
+++ b/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
@@ -40,8 +40,8 @@ public class CropsPumpkinBlock
     }
 
     @Override
-    protected boolean canThisPlantGrowOnThisBlockID(int i) {
-        return i == Blocks.FARMLAND_DIRT.id;
+    protected boolean mayPlaceOn(int blockId) {
+        return blockId == Blocks.FARMLAND_DIRT.id;
     }
 
     @Override
